searchNodes=[{"ref":"EventBus.html","title":"EventBus","type":"module","doc":"Traceable, extendable and minimalist event bus implementation for Elixir with built-in event store and event observation manager based on ETS"},{"ref":"EventBus.html#fetch_event/1","title":"EventBus.fetch_event/1","type":"function","doc":"Fetch an event Examples EventBus.fetch_event({:hello_received, &quot;123&quot;}) %EventBus.Model.Model{}"},{"ref":"EventBus.html#fetch_event_data/1","title":"EventBus.fetch_event_data/1","type":"function","doc":"Fetch an event&#39;s data Examples EventBus.fetch_event_data({:hello_received, &quot;123&quot;})"},{"ref":"EventBus.html#mark_as_completed/1","title":"EventBus.mark_as_completed/1","type":"function","doc":"Mark the event as completed for the subscriber Examples topic = :hello_received event_id = &quot;124&quot; event_shadow = {topic, event_id} # For regular subscribers EventBus.mark_as_completed({MyEventSubscriber, event_shadow}) # For configurable subscribers you must pass tuple of subscriber and config my_config = %{} subscriber = {OtherSubscriber, my_config} EventBus.mark_as_completed({subscriber, event_shadow}) :ok"},{"ref":"EventBus.html#mark_as_skipped/1","title":"EventBus.mark_as_skipped/1","type":"function","doc":"Mark the event as skipped for the subscriber Examples EventBus.mark_as_skipped({MyEventSubscriber, {:unmatched_occurred, &quot;124&quot;}}) # For configurable subscribers you must pass tuple of subscriber and config my_config = %{} subscriber = {OtherSubscriber, my_config} EventBus.mark_as_skipped({subscriber, {:unmatched_occurred, &quot;124&quot;}}) :ok"},{"ref":"EventBus.html#notify/1","title":"EventBus.notify/1","type":"function","doc":"Send an event to all subscribers Examples event = %Event{id: 1, topic: :webhook_received, data: %{&quot;message&quot; =&gt; &quot;Hi all!&quot;}} EventBus.notify(event) :ok"},{"ref":"EventBus.html#register_topic/1","title":"EventBus.register_topic/1","type":"function","doc":"Register a topic Examples EventBus.register_topic(:demo_topic) :ok"},{"ref":"EventBus.html#subscribe/1","title":"EventBus.subscribe/1","type":"function","doc":"Subscribe a subscriber to the event bus Examples EventBus.subscribe({MyEventSubscriber, [&quot;.*&quot;]}) :ok # For configurable subscribers you can pass tuple of subscriber and config my_config = %{} EventBus.subscribe({{OtherSubscriber, my_config}, [&quot;.*&quot;]}) :ok"},{"ref":"EventBus.html#subscribed?/1","title":"EventBus.subscribed?/1","type":"function","doc":"Check if the given subscriber subscribed to the event bus for the given topic patterns Examples EventBus.subscribe({MyEventSubscriber, [&quot;.*&quot;]}) :ok EventBus.subscribed?({MyEventSubscriber, [&quot;.*&quot;]}) true EventBus.subscribed?({MyEventSubscriber, [&quot;some_initialized&quot;]}) false EventBus.subscribed?({AnothEventSubscriber, [&quot;.*&quot;]}) false"},{"ref":"EventBus.html#subscribers/0","title":"EventBus.subscribers/0","type":"function","doc":"List the subscribers Examples EventBus.subscribers() [MyEventSubscriber] # One usual and one configured subscriber with its config EventBus.subscribers() [MyEventSubscriber, {OtherSubscriber, %{}}]"},{"ref":"EventBus.html#subscribers/1","title":"EventBus.subscribers/1","type":"function","doc":"List the subscribers for the given topic Examples EventBus.subscribers(:metrics_received) [MyEventSubscriber] # One usual and one configured subscriber with its config EventBus.subscribers(:metrics_received) [MyEventSubscriber, {OtherSubscriber, %{}}]"},{"ref":"EventBus.html#topic_exist?/1","title":"EventBus.topic_exist?/1","type":"function","doc":"Check if a topic registered Examples EventBus.topic_exist?(:demo_topic) true"},{"ref":"EventBus.html#topics/0","title":"EventBus.topics/0","type":"function","doc":"List all the registered topics Examples EventBus.topics() [:metrics_summed]"},{"ref":"EventBus.html#unregister_topic/1","title":"EventBus.unregister_topic/1","type":"function","doc":"Unregister a topic Examples EventBus.unregister_topic(:demo_topic) :ok"},{"ref":"EventBus.html#unsubscribe/1","title":"EventBus.unsubscribe/1","type":"function","doc":"Unsubscribe a subscriber from the event bus Examples EventBus.unsubscribe(MyEventSubscriber) :ok # For configurable subscribers you must pass tuple of subscriber and config my_config = %{} EventBus.unsubscribe({OtherSubscriber, my_config}) :ok"},{"ref":"EventBus.html#t:event/0","title":"EventBus.event/0","type":"type","doc":"EventBus.Model.Event struct"},{"ref":"EventBus.html#t:event_id/0","title":"EventBus.event_id/0","type":"type","doc":"Event id"},{"ref":"EventBus.html#t:event_shadow/0","title":"EventBus.event_shadow/0","type":"type","doc":"Tuple of topic name and event id"},{"ref":"EventBus.html#t:subscriber/0","title":"EventBus.subscriber/0","type":"type","doc":"Event subscriber"},{"ref":"EventBus.html#t:subscriber_config/0","title":"EventBus.subscriber_config/0","type":"type","doc":"Subscriber configuration"},{"ref":"EventBus.html#t:subscriber_with_config/0","title":"EventBus.subscriber_with_config/0","type":"type","doc":"Event subscriber with config"},{"ref":"EventBus.html#t:subscriber_with_event_ref/0","title":"EventBus.subscriber_with_event_ref/0","type":"type","doc":"Tuple of subscriber and event reference"},{"ref":"EventBus.html#t:subscriber_with_event_shadow/0","title":"EventBus.subscriber_with_event_shadow/0","type":"type","doc":"Tuple of subscriber and event shadow"},{"ref":"EventBus.html#t:subscriber_with_topic_and_event_id/0","title":"EventBus.subscriber_with_topic_and_event_id/0","type":"type","doc":"Tuple of subscriber, topic and event id"},{"ref":"EventBus.html#t:subscriber_with_topic_patterns/0","title":"EventBus.subscriber_with_topic_patterns/0","type":"type","doc":"Tuple of subscriber and list of topic patterns"},{"ref":"EventBus.html#t:subscriber_without_config/0","title":"EventBus.subscriber_without_config/0","type":"type","doc":"Event subscriber without config"},{"ref":"EventBus.html#t:subscribers/0","title":"EventBus.subscribers/0","type":"type","doc":"List of event subscribers"},{"ref":"EventBus.html#t:topic/0","title":"EventBus.topic/0","type":"type","doc":"Topic name"},{"ref":"EventBus.html#t:topic_pattern/0","title":"EventBus.topic_pattern/0","type":"type","doc":"Regex pattern to match topic name"},{"ref":"EventBus.html#t:topic_patterns/0","title":"EventBus.topic_patterns/0","type":"type","doc":"List of topic patterns"},{"ref":"EventBus.html#t:topics/0","title":"EventBus.topics/0","type":"type","doc":"List of topic names"},{"ref":"EventBus.EventSource.html","title":"EventBus.EventSource","type":"module","doc":"Event builder and notifier blocks/yields for EventBus"},{"ref":"EventBus.EventSource.html#build/2","title":"EventBus.EventSource.build/2","type":"macro","doc":"Dynamic event builder block with auto setters It auto sets id, transaction_id, source, ttl, initialized_at and occurred_at fields when they are not provided in the params"},{"ref":"EventBus.EventSource.html#notify/2","title":"EventBus.EventSource.notify/2","type":"macro","doc":"Dynamic event emitter block with auto setters It auto sets id, transaction_id, source, ttl, initialized_at and occurred_at fields when they are not provided in the params"},{"ref":"EventBus.Model.Event.html","title":"EventBus.Model.Event","type":"module","doc":"Structure and type for Event model"},{"ref":"EventBus.Model.Event.html#duration/1","title":"EventBus.Model.Event.duration/1","type":"function","doc":"Calculate the duration of the event, and simple answer of how long does it take to generate this event"},{"ref":"EventBus.Model.Event.html#t:t/0","title":"EventBus.Model.Event.t/0","type":"type","doc":"Definition of the Event struct :id - Identifier :transaction_id - Transaction identifier, if event belongs to a transaction :topic - Topic name :data - Context :initialized_at - When the process initialized to generate this event :occurred_at - When it is occurred :source - Who created this event: module, function or service name are good :ttl - Time to live value"},{"ref":"readme.html","title":"EventBus","type":"extras","doc":"EventBus Traceable, extendable and minimalist event bus implementation for Elixir with built-in event store and event watcher based on ETS."},{"ref":"readme.html#table-of-contents","title":"EventBus - Table of Contents","type":"extras","doc":"Features Getting Started Installation Usage Register event topics in config.exs Register/unregister event topics on demand Subscribe to the &#39;event bus&#39; with a subscriber and list of given topics Unsubscribe from the &#39;event bus&#39; List subscribers List subscribers of a specific event Event data structure Define an event struct Notify all subscribers with EventBus.Model.Event data Fetch an event from the store Mark as completed on Event Observation Manager Mark as skipped on Event Observation Manager Check if a topic exists? Use block builder to build EventBus.Model.Event struct Use block notifier to notify event data to given topic Sample Subscriber Implementation Event Storage Details Traceability EventBus.Metrics and UI Documentation Addons Wiki Contributing License Code of Conduct Questions"},{"ref":"readme.html#features","title":"EventBus - Features","type":"extras","doc":"Fast data writes with enabled concurrent writes to ETS. Fast data reads with enabled concurrent reads from ETS. Fast by design. Almost all implementation data accesses have O(1) complexity. Memory friendly. Instead of pushing event data, pushes event shadow(event id and topic) to only interested subscribers. Applies queueing theory to handle inputs. Extendable with addons. Tracable with optional attributes. Optional attributes compatiable with opentracing platform. Minimal with required attributes(Incase, you want it work minimal use 3 required attributes to deliver your events)."},{"ref":"readme.html#getting-started","title":"EventBus - Getting Started","type":"extras","doc":"Start using event_bus library in five basic steps: 1: Installing Library Package 2: Creating/Registering Topics 3: Emitting/Dispatching an Event 4: Creating Simple Event Consumers/Listeners/Subscribers 5: Subscribing Consumer/Listener/Subscriber for a Topic"},{"ref":"readme.html#installation","title":"EventBus - Installation","type":"extras","doc":"The package can be installed by adding event_bus to your list of dependencies in mix.exs: def deps do [{:event_bus, &quot;~&gt; 1.6.0&quot;}] end Be sure to include event_bus in your mix.exs Mixfile: def application do [ applications: [ # ... :event_bus ] ] end"},{"ref":"readme.html#usage","title":"EventBus - Usage","type":"extras","doc":"Register event topics in config.exs config :event_bus, topics: [:message_received, :another_event_occured] Register/unregister event topics on demand # register EventBus.register_topic(:webhook_received) &gt; :ok # unregister topic # Warning: It also deletes the related topic tables! EventBus.unregister_topic(:webhook_received) &gt; :ok Subscribe to the &#39;event bus&#39; with a subscriber and list of given topics, Notification Manager will match with Regex # to catch every event topic EventBus.subscribe({MyEventSubscriber, [&quot;.*&quot;]}) &gt; :ok # to catch specific topics EventBus.subscribe({MyEventSubscriber, [&quot;purchase_&quot;, &quot;booking_confirmed$&quot;, &quot;flight_passed$&quot;]}) &gt; :ok # if your subscriber has a config config = %{} subscriber = {MyEventSubscriber, config} EventBus.subscribe({subscriber, [&quot;.*&quot;]}) &gt; :ok Unsubscribe from the &#39;event bus&#39; EventBus.unsubscribe(MyEventSubscriber) &gt; :ok # if your subscriber has a config config = %{} EventBus.unsubscribe({MyEventSubscriber, config}) &gt; :ok List subscribers EventBus.subscribers() &gt; [{MyEventSubscriber, [&quot;.*&quot;]}, {{AnotherSubscriber, %{}}, [&quot;.*&quot;]}] List subscribers of a specific event EventBus.subscribers(:hello_received) &gt; [MyEventSubscriber, {{AnotherSubscriber, %{}}}] Event data structure Data structure for EventBus.Model.Event %EventBus.Model.Event{ id: String.t | integer(), # required transaction_id: String.t | integer(), # optional topic: atom(), # required data: any() # required, initialized_at: integer(), # optional, might be seconds, milliseconds or microseconds even nanoseconds since Elixir does not have a limit on integer size occurred_at: integer(), # optional, might be seconds, milliseconds or microseconds even nanoseconds since Elixir does not have a limit on integer size source: String.t, # optional, source of the event, who created it ttl: integer() # optional, might be seconds, milliseconds or microseconds even nanoseconds since Elixir does not have a limit on integer size. If `ttl` field is set, it is recommended to set `occurred_at` field too. } transaction_id attribute Firstly, transaction_id attribute is an optional field, if you need to store any meta identifier related to event transaction, it is the place to store. Secondly, transaction_id is one of the good ways to track events related to the same transaction on a chain of events. If you have time, have a look to the story. initialized_at attribute Optional, but good to have field for all events to track when the event generator started to process for generating this event. occurred_at attribute Optional, but good to have field for all events to track when the event occurred with unixtimestamp value. The library does not automatically set this value since the value depends on the timing choice. ttl attribute Optional, but might to have field for all events to invalidate an event after a certain amount of time. Currently, the event_bus library does not do any specific thing using this field. If you need to discard an event in a certain amount of time, that field would be very useful. Note: If you set this field, then occurred_at field is required. Define an event struct alias EventBus.Model.Event event = %Event{id: &quot;123&quot;, transaction_id: &quot;1&quot;, topic: :hello_received, data: %{message: &quot;Hello&quot;}} another_event = %Event{id: &quot;124&quot;, transaction_id: &quot;1&quot;, topic: :bye_received, data: [user_id: 1, goal: &quot;exit&quot;]} Important Note: It is important to have unique identifier for each event struct per topic. I recommend to use a unique id generator like {:uuid, &quot;~&gt; 1.1&quot;}. Notify all subscribers with EventBus.Model.Event data EventBus.notify(event) &gt; :ok EventBus.notify(another_event) &gt; :ok Fetch an event from the store topic = :bye_received id = &quot;124&quot; EventBus.fetch_event({topic, id}) &gt; %EventBus.Model.Event{data: [user_id: 1, goal: &quot;exit&quot;], id: &quot;124&quot;, topic: :bye_received, transaction_id: &quot;1&quot;} # To fetch only the event data EventBus.fetch_event_data({topic, id}) &gt; [user_id: 1, goal: &quot;exit&quot;] Mark as completed on Event Observation Manager subscriber = MyEventSubscriber # If your subscriber has config then pass tuple subscriber = {MyEventSubscriber, config} EventBus.mark_as_completed({subscriber, {:bye_received, id}}) &gt; :ok Mark as skipped on Event Observation Manager subscriber = MyEventSubscriber # If your subscriber has config then pass tuple subscriber = {MyEventSubscriber, config} EventBus.mark_as_skipped({subscriber, {:bye_received, id}}) &gt; :ok Check if a topic exists? EventBus.topic_exist?(:metrics_updated) &gt; false Use block builder to build EventBus.Model.Event struct Builder automatically sets initialized_at and occurred_at attributes use EventBus.EventSource id = &quot;some unique id&quot; topic = :user_created transaction_id = &quot;tx&quot; # optional ttl = 600_000 # optional source = &quot;my event creator&quot; # optional params = %{id: id, topic: topic, transaction_id: transaction_id, ttl: ttl, source: source} EventSource.build(params) do # do some calc in here Process.sleep(1) # as a result return only the event data %{email: &quot;jd@example.com&quot;, name: &quot;John Doe&quot;} end &gt; %EventBus.Model.Event{data: %{email: &quot;jd@example.com&quot;, name: &quot;John Doe&quot;}, id: &quot;some unique id&quot;, initialized_at: 1515274599140491, occurred_at: 1515274599141211, source: &quot;my event creator&quot;, topic: :user_created, transaction_id: &quot;tx&quot;, ttl: 600000} It is recommended to set optional params in event_bus application config, this will allow you to auto generate majority of optional values without writing code. Here is a sample config for event_bus: config :event_bus, topics: [], # list of atoms ttl: 30_000_000, # integer time_unit: :microsecond, # atom id_generator: EventBus.Util.Base62 # module: must implement &#39;unique_id/0&#39; function After having such config like above, you can generate events without providing optional attributes like below: # Without optional params params = %{topic: topic} EventSource.build(params) do %{email: &quot;jd@example.com&quot;, name: &quot;John Doe&quot;} end &gt; %EventBus.Model.Event{data: %{email: &quot;jd@example.com&quot;, name: &quot;John Doe&quot;}, id: &quot;Ewk7fL6Erv0vsW6S&quot;, initialized_at: 1515274599140491, occurred_at: 1515274599141211, source: &quot;AutoModuleName&quot;, topic: :user_created, transaction_id: nil, ttl: 30_000_000} # With optional error topic param params = %{id: id, topic: topic, error_topic: :user_create_erred} EventSource.build(params) do {:error, %{email: &quot;Invalid format&quot;}} end &gt; %EventBus.Model.Event{data: {:error, %{email: &quot;Invalid format&quot;}}, id: &quot;some unique id&quot;, initialized_at: 1515274599140491, occurred_at: 1515274599141211, source: nil, topic: :user_create_erred, transaction_id: nil, ttl: 30_000_000} Use block notifier to notify event data to given topic Builder automatically sets initialized_at and occurred_at attributes use EventBus.EventSource id = &quot;some unique id&quot; topic = :user_created error_topic = :user_create_erred # optional (incase error tuple return in yield execution, it will use :error_topic value as :topic for event creation) transaction_id = &quot;tx&quot; # optional ttl = 600_000 # optional source = &quot;my event creator&quot; # optional EventBus.register_topic(topic) # incase you didn&#39;t register it in `config.exs` params = %{id: id, topic: topic, transaction_id: transaction_id, ttl: ttl, source: source, error_topic: error_topic} EventSource.notify(params) do # do some calc in here # as a result return only the event data %{email: &quot;mrsjd@example.com&quot;, name: &quot;Mrs Jane Doe&quot;} end &gt; # it automatically calls notify method with event data and return only event data as response &gt; %{email: &quot;mrsjd@example.com&quot;, name: &quot;Mrs Jane Doe&quot;} Sample Subscriber Implementation defmodule MyEventSubscriber do ... # if your subscriber does not have a config def process({topic, id} = event_shadow) do GenServer.cast(__MODULE__, event_shadow) :ok end ... # if your subscriber has a config def process({config, topic, id} = event_shadow_with_conf) do GenServer.cast(__MODULE__, event_shadow_with_conf) :ok end ... # if your subscriber does not have a config def handle_cast({:bye_received, id} = event_shadow, state) do event = EventBus.fetch_event(event_shadow) # do sth with event # update the watcher! # version &gt;= 1.4.0 EventBus.mark_as_completed({__MODULE__, event_shadow}) # all versions EventBus.mark_as_completed({__MODULE__, :bye_received, id}) ... {:noreply, state} end def handle_cast({:hello_received, id} = event_shadow, state) do event = EventBus.fetch_event({:hello_received, id}) # do sth with EventBus.Model.Event # update the watcher! # version &gt;= 1.4.0 EventBus.mark_as_completed({__MODULE__, event_shadow}) # all versions EventBus.mark_as_completed({__MODULE__, :hello_received, id}) ... {:noreply, state} end def handle_cast({topic, id} = event_shadow, state) do # version &gt;= 1.4.0 EventBus.mark_as_skipped({__MODULE__, event_shadow}) # all versions EventBus.mark_as_skipped({__MODULE__, topic, id}) {:noreply, state} end ... # if your subscriber has a config def handle_cast({config, :bye_received, id}, state) do event = EventBus.fetch_event({:bye_received, id}) # do sth with event # update the watcher! subscriber = {__MODULE__, config} EventBus.mark_as_completed({subscriber, :bye_received, id}) ... {:noreply, state} end def handle_cast({config, :hello_received, id}, state) do event = EventBus.fetch_event({:hello_received, id}) # do sth with EventBus.Model.Event # update the watcher! subscriber = {__MODULE__, config} EventBus.mark_as_completed({subscriber, :hello_received, id}) ... {:noreply, state} end def handle_cast({config, topic, id}, state) do subscriber = {__MODULE__, config} EventBus.mark_as_skipped({subscriber, topic, id}) {:noreply, state} end ... end"},{"ref":"readme.html#event-storage-details","title":"EventBus - Event Storage Details","type":"extras","doc":"When an event configured in config file, 2 ETS tables will be created for the event on app start. All event data is temporarily saved to the ETS tables with the name :eb_es_&lt;&lt;topic&gt;&gt; until all subscribers processed the data. This table is a read heavy table. When a subscriber needs to process the event data, it queries this table to fetch event data. To watch event status, a separate watcher table is created for each event type with the name :eb_ew_&lt;&lt;topic&gt;&gt;. This table is used for keeping the status of the event. Observation Manager updates this table frequently with the notification of the event subscribers. When all subscribers process the event data, data in the event store and watcher, automatically deleted by the Observation Manager. If you need to see the status of unprocessed events, event watcher table is one of the good places to query. For example; to get the list unprocessed events for :hello_received event: # The following command will return a list of tuples with the `id`, and `event_subscribers_list` where `subscribers` is the list of event subscribers, `completers` is the subscribers those processed the event and notified `Observation Manager`, and lastly `skippers` is the subscribers those skipped the event without processing. # Assume you have an event with the name &#39;:hello_received&#39; :ets.tab2list(:eb_ew_hello_received) &gt; [{id, {subscribers, completers, skippers}}, ...] ETS storage SHOULD NOT be considered as a persistent storage. If you need to store events to a persistant data store, then subscribe to all event types by a module with [&quot;.*&quot;] event topic then save every event data. For example; EventBus.subscribe({MyDataStore, [&quot;.*&quot;]}) # then in your data store save the event defmodule MyDataStore do ... def process({topic, id} = event_shadow) do GenServer.cast(__MODULE__, event_shadow) :ok end ... def handle_cast({topic, id}, state) do event = EventBus.fetch_event({topic, id}) # write your logic to save event_data to a persistant store EventBus.mark_as_completed({__MODULE__, {topic, id}}) {:noreply, state} end end"},{"ref":"readme.html#traceability","title":"EventBus - Traceability","type":"extras","doc":"EventBus comes with a good enough data structure to track the event life cycle with its optional parameters. For a traceable system, it is highly recommend to fill optional fields on event data. It is also encouraged to use EventSource.nofify block/yield to automatically set the initialized_at and occurred_at values. System Events This feature removed with the version 1.3 to keep the core library simple. If you need to trace system events please check the sample wrapper implementation from the wiki page. EventBus.Metrics Library EventBus has some addons to extend its optional functionalities. One of them is event_bus_metrics libray which comes with a UI, RESTFul endpoints and SSE streams to provide instant metrics for event_bus topics. EventBus.Metrics Instructions"},{"ref":"readme.html#documentation","title":"EventBus - Documentation","type":"extras","doc":"Wiki Module docs The story"},{"ref":"readme.html#addons","title":"EventBus - Addons","type":"extras","doc":"A few sample addons listed below. Please do not hesitate to add your own addon to the list. Addon NameDescriptionLinkDocs event_bus_postgresFast event consumer to persist event_bus events to Postgres using GenStageGithubHexDocs event_bus_loggerDeadly simple log subscriber implementationGithubHexDocs event_bus_metricsMetrics UI and metrics API endpoints for EventBus events for debugging and monitoringHexHexDocs Note: The addons under https://github.com/otobus organization implemented as a sample, but feel free to use them in your project with respecting their licenses."},{"ref":"readme.html#license","title":"EventBus - License","type":"extras","doc":"MIT Copyright (c) 2019 Mustafa Turan Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]